package com.io.yutian.auchestshop;

import com.io.yutian.auchestshop.command.CommandManager;
import com.io.yutian.auchestshop.database.SQLIO;
import com.io.yutian.auchestshop.listener.ShopListener;
import com.io.yutian.auchestshop.manager.InteractiveManager;
import com.io.yutian.auchestshop.manager.ShopManager;
import com.io.yutian.aulib.lang.Lang;
import org.bukkit.plugin.java.JavaPlugin;

public class AuChestShop extends JavaPlugin {

    private static AuChestShop instance;

    private static SQLIO sqlIO;
    private static ShopManager shopManager;
    private static CommandManager commandManager;
    private static InteractiveManager interactiveManager;

    @Override
    public void onEnable() {
        instance = this;

        sqlIO = new SQLIO();
        commandManager = new CommandManager();
        shopManager = new ShopManager();
        interactiveManager = new InteractiveManager();
        commandManager.registerBukkitCommand(this, "auchestshop");

        registerListeners();

        Lang.registerLangFile(this);
        reload();
        try {
            sqlIO.init();
        } catch (Exception e) {
            e.printStackTrace();
        }
        shopManager.loadAll(sqlIO);
    }

    public void reload() {
        Lang.reload(this);
    }

    @Override
    public void onDisable() {
        sqlIO.close();
    }

    private void registerListeners() {
        new ShopListener(this);
    }

    public static SQLIO getSQLIO() {
        return sqlIO;
    }

    public static ShopManager getShopManager() {
        return shopManager;
    }

    public static CommandManager getCommandManager() {
        return commandManager;
    }

    public static InteractiveManager getInteractiveManager() {
        return interactiveManager;
    }

    public static AuChestShop inst() {
        return instance;
    }

}
